<template>
  <VContainer
    fluid
    fill-height
  >
    <VLayout
      row
      wrap
    >
      <!-- View -->
      <VTreeview
        ref="treeview"
        :items="data"
        :active.sync="active"
        :search="search"
        item-text="descricao"
        item-children="filhos"
        active-class="primary--text"
        activatable
        return-object
        transition
      >
        <template v-slot:prepend="{ item }">
          {{ item.codigo }}
        </template>
      </VTreeview>
    </VLayout>

    <!-- Add | Edit | Del -->
    <VScaleTransition>
      <VBtn
        v-if="crud.bool"
        fab
        fixed
        bottom
        right
        small
        :style="{
          right: '24px',
          bottom: `${$vuetify.application.footer + 8 + 64}px`
        }"
        color="red"
        dark
        @click="del"
      >
        <VIcon>delete</VIcon>
      </VBtn>
    </VScaleTransition>
    <VDialog
      v-model="dialog"
      :width="500"
      persistent
    >
      <template v-slot:activator="{ on }">
        <VBtn
          fab
          fixed
          bottom
          right
          :style="{
            bottom: `${$vuetify.application.footer + 8}px`,
          }"
          :color="crud.color"
          dark
          v-on="on"
        >
          <VIcon>{{ crud.type }}</VIcon>
        </VBtn>
      </template>

      <VCard class="user-form">
        <VForm
          ref="form"
          class="v-card__text"
        >
          <VContainer
            fluid
            pa-0
          >
            <VTextField
              v-model.number="form.codigo"
              label="Código"
              :rules="[v.required]"
            />

            <VTextField
              v-model="form.descricao"
              label="Descrição"
              :rules="[v.required]"
            />

            <VAutocomplete
              v-if="!crud.bool"
              v-model="form.idPai"
              label="Plano"
              :items="items"
              item-text="name"
              item-value="id"
            />
          </VContainer>
        </VForm>

        <VDivider />

        <VCardActions class="pa-3">
          <VSpacer />
          <VBtn
            flat
            @click="dialog = false"
          >
            Cancelar
          </VBtn>
          <VBtn
            flat
            color="primary"
            @click="submit"
          >
            Enviar
          </VBtn>
        </VCardActions>
      </VCard>
    </VDialog>
  </VContainer>
</template>

<script lang="ts">
import {
  Component, mixins, State, Mutation, Watch,
} from 'nuxt-property-decorator';

import Rules from '@/mixins/rules';

interface Form {
  codigo: number | null
  descricao: string
  idPai: number | null
}

interface items {
  id: number | null
  name: string
}

@Component({
  async asyncData({ $axios, error }) {
    try {
      const { data } = await $axios.get('/v1/planocontas/filhos');

      return { data };
    } catch (e) {
      return error(e);
    }
  },
})
export default class Index extends mixins(Rules) {
  @State
  search!: string

  @State
  searchFocus!: boolean

  @Mutation
  setMsg!: (key: Object) => void

  data: any[] = []

  items: items[] = []

  active: any[] = []

  dialog = false

  form: Form = {
    codigo: null,
    descricao: '',
    idPai: null,
  }

  mounted() {
    this.updateItems();
  }

  get crud() {
    const bool = this.active.length > 0;

    return {
      type: bool ? 'edit' : 'add',
      color: bool ? 'green' : 'purple',
      bool,
    };
  }

  private async submit() {
    if ((this.$refs.form as any).validate()) {
      try {
        const { data, status } = this.crud.bool
          ? await this.$axios.put(`/v1/planocontas/${this.active[0].id}`, this.form)
          : await this.$axios.post('/v1/planocontas', this.form);

        if ([200, 201].includes(status)) {
          this.setMsg({
            bool: true,
            color: 'success',
            message: `${status === 200 ? 'Atualizado' : 'Criado'} com sucesso.`,
          });

          if (this.crud.bool) {
            this.add(this.active[0].id, 'set');
            this.active = [];
          } else this.add(data);

          this.dialog = false;
        } else {
          this.onError();
        }
      } catch ({ message }) {
        this.setMsg({
          bool: true,
          color: 'error',
          message,
        });
      }
    }
  }

  async add(id: number, type = 'add') {
    if (id) {
      const searchSet = (obj: any[], value: any[]) => {
        Object.values(obj).forEach((elem, i) => {
          if (elem.id === id) {
            this.$set(obj, i, value);
          } else if (elem.filhos) {
            searchSet(elem.filhos, value);
          }
        });
      };

      const searchAdd = (obj: any[], value: any[] | any) => {
        Object.values(obj).forEach((elem, i) => {
          if (elem.id === value.idPai) {
            elem.filhos.push(value);
          } else if (elem.filhos) {
            searchAdd(elem.filhos, value);
          }
        });
      };

      try {
        const { data, status } = await this.$axios.get(`/v1/planocontas/${id}/filhos`);

        if (status === 200) {
          if (type === 'add') {
            if (data.idPai === null) this.data.push(data);
            else searchAdd(this.data, data);
          } else {
            searchSet(this.data, data);
          }
          this.updateItems();
        } else {
          this.onError();
        }
      } catch ({ message }) {
        this.setMsg({
          bool: true,
          color: 'error',
          message,
        });
      }
    } else {
      this.onError();
    }
  }

  async del() {
    const searchDel = (obj: any[]) => {
      Object.values(obj).forEach((elem, i) => {
        if (elem.id === this.active[0].id) {
          this.$delete(obj, i);
        } else if (elem.filhos) {
          searchDel(elem.filhos);
        }
      });
    };

    try {
      const { status } = await this.$axios.delete(`/v1/planocontas/${this.active[0].id}`);
      if (status === 200) {
        this.setMsg({
          bool: true,
          color: 'success',
          message: 'Deletado com sucesso.',
        });

        searchDel(this.data);
        this.updateItems();
        this.active = [];
      } else {
        this.onError();
      }
    } catch ({ message }) {
      this.setMsg({
        bool: true,
        color: 'error',
        message,
      });
    }
  }

  private onError() {
    this.setMsg({
      bool: true,
      color: 'error',
      message: 'Ocorreu um erro ao processar o pedido, por favor atualize a página.',
    });
  }

  private resetForm() {
    (this.$refs.form as any).resetValidation();
    this.form = {
      codigo: null,
      descricao: '',
      idPai: null,
    };
  }

  updateItems() {
    const changeObj = (obj: any[], save: any[]) => Object.values(obj).forEach((elem) => {
      save.push({ id: elem.id, name: `${elem.codigo} ${elem.descricao}` });
      if (elem.filhos) changeObj(elem.filhos, save);
    });

    this.items = [
      {
        id: null,
        name: 'Novo plano',
      },
    ];
    changeObj(this.data, this.items);
  }

  @Watch('searchFocus')
  private changeFocus(bool: boolean) {
    (this.$refs.treeview as any).updateAll(bool);

    if (bool === false) this.active = [];
  }

  @Watch('dialog')
  private changeForm(bool: boolean) {
    if (bool) {
      if (this.crud.bool) {
        this.form = {
          codigo: parseFloat(this.active[0].codigo),
          descricao: this.active[0].descricao,
          idPai: this.active[0].idPai === null
            ? this.active[0].idPai
            : Number(this.active[0].idPai),
        };
      } else {
        this.resetForm();
      }
    } else {
      this.resetForm();
    }
  }
}
</script>

<style lang="stylus">
.user-form
  .v-messages
    min-height 14px
</style>
